// -------------------------------------------------------------
// lZ
//
//												(C)2000 HRA!
// -------------------------------------------------------------

#include "calc.h"
#include "string.h"
#include <ctype.h>

// -------------------------------------------------------------
// ݒ

static const int calc_level_max = 50;		// JbR̃lXgxő
#define WORD_SIZE	128						// P̍őTCY

// -------------------------------------------------------------
// O[oϐ

typedef struct {
	char	*s_word;
	int		n_class;
} t_calc_words;

const t_calc_words calc_operator[]={
	{ "("	, calc_class_lpar	},
	{ ")"	, calc_class_rpar	},
	{ "+"	, calc_class_plus	},
	{ "-"	, calc_class_minus	},
	{ "*"	, calc_class_mul	},
	{ "/"	, calc_class_div	},
	{ "%"	, calc_class_mod	},
	{ "&"	, calc_class_and	},
	{ "|"	, calc_class_or		},
	{ "^"	, calc_class_xor	},
	{ "~"	, calc_class_not	},
	{ "MOD"	, calc_class_mod	},
	{ "AND"	, calc_class_and	},
	{ "OR"	, calc_class_or		},
	{ "XOR"	, calc_class_xor	},
	{ "NOT"	, calc_class_not	},
};

// -------------------------------------------------------------
// vg^Cv錾

static void calc_exp0( t_calc_param *p_calcpar );
static void calc_exp1( t_calc_param *p_calcpar );
static void calc_exp2( t_calc_param *p_calcpar );
static void calc_exp3( t_calc_param *p_calcpar );
static void calc_exp4( t_calc_param *p_calcpar );
static void calc_exp5( t_calc_param *p_calcpar );
static void calc_getword( t_calc_param *p_calcpar );
static bool calc_isexp( t_calc_param *p_calcpar );
static bool calc_isnumber( t_calc_param *p_calcpar );
static bool calc_ishexnumber( t_calc_param *p_calcpar );
static bool calc_isdecnumber( t_calc_param *p_calcpar );
static bool calc_isbinnumber( t_calc_param *p_calcpar );
static inline bool isbindigit( int c );
static inline void calc_skipspace( t_calc_param *p_calcpar );

// -------------------------------------------------------------
//	1.	{ꖼ
//		ZJn
//	2.	
//		p_calcpar	...	(I/O)	Zp\̂̃|C^ig
//								܂j
//		s_line		...	(I)		Z
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool calc_exp( int *n_result,const char *s_line,int *ptr )
{
	t_calc_param p_calcpar;
	// \̂̏
	p_calcpar.n_class		= calc_class_none;
	p_calcpar.s_line		= s_line;
	p_calcpar.n_ptr			= 0;
	p_calcpar.n_result		= 0;
	p_calcpar.b_lpar		= false;
	p_calcpar.n_level		= 0;
	p_calcpar.b_number		= true;
	// ZJn
	try{
		calc_exp0( &p_calcpar );
	}catch( int err ){
		*n_result = err;
		return false;
	}
	*n_result = p_calcpar.n_result;
	*ptr = p_calcpar.n_ptr;
	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Z
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void calc_exp0( t_calc_param *p_calcpar )
{
	// JbRlXgx𑝉
	++(p_calcpar->n_level);
	if( p_calcpar->n_level > calc_level_max ){
		throw( (int)calc_err_level );
		return;
	}
	// 擾
	calc_exp1( p_calcpar );
	// 𔻒肷
	if( p_calcpar->b_lpar ){
		if( p_calcpar->n_class == calc_class_rpar ){
			--(p_calcpar->n_level);
			return;
		}
	}else{
		if( p_calcpar->n_class == calc_class_none ){
			--(p_calcpar->n_level);
			return;
		}
	}
	// sȉZq܂͒l݂
	throw( (int)calc_err_syntax );
	return;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ZqixPj
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void calc_exp1( t_calc_param *p_calcpar )
{
	int n_value;
	int n_class;
	// 擾
	calc_exp2( p_calcpar );
	for(;;){
		// 擾l
		n_value = p_calcpar->n_result;
		n_class = p_calcpar->n_class;
		// Zq]
		switch( p_calcpar->n_class ){
		case calc_class_or:
			calc_exp2( p_calcpar );
			p_calcpar->n_result |= n_value;
			break;
		case calc_class_xor:
			calc_exp2( p_calcpar );
			p_calcpar->n_result ^= n_value;
			break;
		default:
			return;
		}
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ZqixQj
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void calc_exp2( t_calc_param *p_calcpar )
{
	int n_value;
	int n_class;
	// 擾
	calc_exp3( p_calcpar );
	for(;;){
		// 擾l
		n_value = p_calcpar->n_result;
		n_class = p_calcpar->n_class;
		// Zq]
		switch( p_calcpar->n_class ){
		case calc_class_and:
			calc_exp3( p_calcpar );
			p_calcpar->n_result &= n_value;
			break;
		default:
			return;
		}
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ZqixRj
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void calc_exp3( t_calc_param *p_calcpar )
{
	int n_value;
	int n_class;
	// 擾
	calc_exp4( p_calcpar );
	for(;;){
		// 擾l
		n_value = p_calcpar->n_result;
		n_class = p_calcpar->n_class;
		// Zq]
		switch( n_class ){
		case calc_class_plus:
			calc_exp4( p_calcpar );
			p_calcpar->n_result += n_value;
			break;
		case calc_class_minus:
			calc_exp4( p_calcpar );
			p_calcpar->n_result = n_value - p_calcpar->n_result;
			break;
		default:
			return;
		}
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ZqixSj
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void calc_exp4( t_calc_param *p_calcpar )
{
	int n_value;
	int n_class;
	// 擾
	calc_exp5( p_calcpar );
	for(;;){
		// 擾l
		n_value = p_calcpar->n_result;
		n_class = p_calcpar->n_class;
		// Zq]
		switch( n_class ){
		case calc_class_mul:
			calc_exp5( p_calcpar );
			p_calcpar->n_result *= n_value;
			break;
		case calc_class_div:
			calc_exp5( p_calcpar );
			if( p_calcpar->n_result == 0 ) throw( (int)calc_err_divided_by_zero );
			p_calcpar->n_result = n_value / p_calcpar->n_result;
			break;
		case calc_class_mod:
			calc_exp5( p_calcpar );
			if( p_calcpar->n_result == 0 ) throw( (int)calc_err_divided_by_zero );
			p_calcpar->n_result = n_value % p_calcpar->n_result;
			break;
		default:
			return;
		}
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		ZqixTj
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static void calc_exp5( t_calc_param *p_calcpar )
{
	int n_class;
	bool b_lpar;
	// P擾
	calc_getword( p_calcpar );
	// 擾l
	n_class = p_calcpar->n_class;
	// Zq]
	switch( n_class ){
	case calc_class_minus:
		p_calcpar->b_number = true;
		calc_exp5( p_calcpar );
		p_calcpar->n_result = -(p_calcpar->n_result);
		break;
	case calc_class_plus:
		p_calcpar->b_number = true;
		calc_exp5( p_calcpar );
		break;
	case calc_class_not:
		p_calcpar->b_number = true;
		calc_exp5( p_calcpar );
		p_calcpar->n_result = ~(p_calcpar->n_result);
		break;
	case calc_class_lpar:
		b_lpar = p_calcpar->b_lpar;
		p_calcpar->b_lpar = true;
		p_calcpar->b_number = true;
		calc_exp0( p_calcpar );
		p_calcpar->b_lpar = b_lpar;
		calc_getword( p_calcpar );
		if( p_calcpar->n_class == calc_class_const ){
			throw( (int)calc_err_syntax );
			return;
		}
		break;
	case calc_class_const:
		p_calcpar->b_number = false;
		calc_getword( p_calcpar );
		if( p_calcpar->n_class == calc_class_const ){
			throw( (int)calc_err_syntax );
			return;
		}
		break;
	case calc_class_none:
		if( p_calcpar->b_number ){
			throw( (int)calc_err_syntax );
			return;
		}
		break;
	}
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		P̎擾
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		萔Ȃ炻̒l n_result ֕ԂAZqȂ n_result ͔j󂵂Ȃ
// -------------------------------------------------------------
static void calc_getword( t_calc_param *p_calcpar )
{
	// zCgXy[XXLbv
	calc_skipspace( p_calcpar );
	// Zqǂf
	if( calc_isexp( p_calcpar ) ) return;
	// 萔ǂf
	if( calc_isnumber( p_calcpar ) ) return;
	// ȊO
	if( p_calcpar->n_class!=calc_class_none &&
		p_calcpar->n_class!=calc_class_const &&
		p_calcpar->n_class!=calc_class_rpar )
		throw( (int)calc_err_syntax );
	p_calcpar->n_class = calc_class_none;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Zqǂf
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		true	...	Zq
//		false	...	ȊO
//	4.	l
//		ZqȂ p_calcpar->n_class ɉZqނ
// -------------------------------------------------------------
static bool calc_isexp( t_calc_param *p_calcpar )
{
	int i,j,n_ptr,n_class,l;
	char *s_word;
	n_ptr = p_calcpar->n_ptr;
	for( i=0;i<calc_arraysize( calc_operator );++i ){
		s_word  = calc_operator[i].s_word;
		n_class = calc_operator[i].n_class;
		l = strlen( s_word );
		for( j=0;j<l;j++ ){
			if( (int)s_word[j] != toupper( p_calcpar->s_line[ n_ptr+j ] ) ){
				n_class = calc_class_none;
				break;
			}
		}
		if( n_class != calc_class_none ){
			p_calcpar->n_class = n_class;	// vZq
			p_calcpar->n_ptr += j;			// Zq̎̈ʒu
			return true;
		}
	}
	return false;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		萔ǂf
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		true	...	萔
//		false	...	ȊO
//	4.	l
//		萔Ȃ p_calcpar ɒ萔ǂݍ
// -------------------------------------------------------------
static bool calc_isnumber( t_calc_param *p_calcpar )
{
	if( calc_ishexnumber( p_calcpar ) ) return true;	// 16i
	if( calc_isbinnumber( p_calcpar ) ) return true;	//  2i
	if( calc_isdecnumber( p_calcpar ) ) return true;	// 10i
	return false;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		PUiǂ肷
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		true	...	PUi
//		false	...	ȊO
//	4.	l
//		PUiȂ p_calcpar ɒ萔ǂݍ
// -------------------------------------------------------------
static bool calc_ishexnumber( t_calc_param *p_calcpar )
{
	char word[ WORD_SIZE ] = "";
	int pword = 0;
	int n_ptr;
	int n_result = 0;
	int n;
	const int n_base = 16;
	// 擪͕Kl
	n_ptr = p_calcpar->n_ptr;
	if( !isdigit( p_calcpar->s_line[ n_ptr ] ) ) return false;
	while( isxdigit( p_calcpar->s_line[ n_ptr ] ) && pword < WORD_SIZE-1 ){
		word[ pword++ ] = (char)toupper( p_calcpar->s_line[ n_ptr++ ] );
	}
	word[ pword ] = 0;
	// 16iCqF
	if( (char)toupper( p_calcpar->s_line[ n_ptr ] )!='H' ){
		return false;
	}
	++n_ptr;
	// ̈ʒu
	p_calcpar->n_ptr = n_ptr;
	// lɕϊ
	n_ptr = 0;
	while( word[ n_ptr ]!='\0' ){
		if( isdigit( word[ n_ptr ] ) ){
			n = word[ n_ptr ] - '0';
		}else{
			n = word[ n_ptr ] - 'A' + 10;
		}
		n_result = n_result * n_base + n;
		++n_ptr;
	}
	p_calcpar->n_result = n_result;
	p_calcpar->n_class = calc_class_const;
	return true;

}

// -------------------------------------------------------------
//	1.	{ꖼ
//		POiǂ肷
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		true	...	POi
//		false	...	ȊO
//	4.	l
//		POiȂ p_calcpar ɒ萔ǂݍ
// -------------------------------------------------------------
static bool calc_isdecnumber( t_calc_param *p_calcpar )
{
	char word[ WORD_SIZE ] = "";
	int pword=0;
	int n_ptr;
	int n_result = 0;
	int n;
	const int n_base = 10;
	// 擪͕Kl
	n_ptr = p_calcpar->n_ptr;
	if( !isdigit( p_calcpar->s_line[ n_ptr ] ) ) return false;
	while( isdigit( p_calcpar->s_line[ n_ptr ] ) && pword < WORD_SIZE-1 ){
		word[ pword++ ] = (char)(p_calcpar->s_line[ n_ptr++ ]);
	}
	word[ pword ]=0;
	// 10iCqFiȗ\j
	if( (char)toupper( p_calcpar->s_line[ n_ptr ] )=='D' ){
		++n_ptr;
	}
	// ̈ʒu
	p_calcpar->n_ptr = n_ptr;
	// lɕϊ
	n_ptr = 0;
	while( word[ n_ptr ]!='\0' ){
		n = word[ n_ptr ] - '0';
		n_result = n_result * n_base + n;
		++n_ptr;
	}
	p_calcpar->n_result = n_result;
	p_calcpar->n_class = calc_class_const;
	return true;

}

// -------------------------------------------------------------
//	1.	{ꖼ
//	Qiǂ肷
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		true	...	Qi
//		false	...	ȊO
//	4.	l
//		萔Ȃ p_calcpar ɒ萔ǂݍ
// -------------------------------------------------------------
static bool calc_isbinnumber( t_calc_param *p_calcpar )
{
	char word[ WORD_SIZE ] = "";
	int pword=0;
	int n_ptr;
	int n_result = 0;
	int n;
	const int n_base = 2;
	// 擪͕K 0  1
	n_ptr = p_calcpar->n_ptr;
	if( !isbindigit( p_calcpar->s_line[ n_ptr ] ) ) return false;
	while( isbindigit( p_calcpar->s_line[ n_ptr ] ) && pword < WORD_SIZE-1 ){
		word[ pword++ ] = (char)(p_calcpar->s_line[ n_ptr++ ]);
	}
	word[ pword ] = 0;
	// 2iCqF
	if( (char)toupper( p_calcpar->s_line[ n_ptr ] )!='B' ){
		return false;
	}
	++n_ptr;
	// ̈ʒu
	p_calcpar->n_ptr = n_ptr;
	// lɕϊ
	n_ptr = 0;
	while( word[ n_ptr ]!='\0' ){
		n = word[ n_ptr ] - '0';
		n_result = n_result * n_base + n;
		++n_ptr;
	}
	p_calcpar->n_result = n_result;
	p_calcpar->n_class = calc_class_const;
	return true;

}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Qǐǂ肷
//	2.	
//		c	...	(I)	
//	3.	Ԓl
//		true	...	Qǐ
//		false	...	ȊO
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static inline bool isbindigit( int c )
{
	return( c=='0' || c=='1' );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		zCgXy[XXLbv
//	2.	
//		p_calcpar	...	(I)	Zp\̂̃|C^
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
static inline void calc_skipspace( t_calc_param *p_calcpar )
{
	while( isspace( p_calcpar->s_line[ p_calcpar->n_ptr ] ) ) ++(p_calcpar->n_ptr);
}
