// -------------------------------------------------------------
//	TITLE		:	File Access Utility
//	FILE		:	fileuty.cpp
//	COPYRIGHT	:	(C)2001 t.hara
//	COMENT		:	t@CANZX֐Q
//					bW̃t@CANZX֐ƎC^[tF[X
//					̗p WindowsAPI x[X̊֐Q
//					bW̃t@CANZXɂssA
//					Windows ȊOւ̈ڐAێړI
//	HISTORY		:	2001/02/07	v0.00	Jn
//					2001/02/11	v1.00	{@\̎
//					2001/02/14	v1.01	ANZX@\ǉ
// -------------------------------------------------------------

// =============================================================
//	CN[h

#include "fileuty.h"				//	g̃wb_
#include "typeuty.h"				//	^[eBeB
#include <stdio.h>					//	vstringf
#include <stdarg.h>					//	va_start / va_end

// =============================================================
//	⏕֐̃vg^CviJ֐j

inline bool _fu_check_enable( FU_FILE* p_file );
void _fu_change_cr( char* s_buffer );
void _fu_change_crlf( char* s_buffer );

// =============================================================
//	֐`

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CJ
//	2.	
//		s_filename	...	(I)	t@C
//		s_option	...	(I)	ANZXw
//								"rt"	...	eLXgǂݍ݃ANZX
//								"wt"	...	eLXgǂݏANZX
//								"at"	...	eLXgǉ݃ANZX
//								"rb"	...	oCiǂݍ݃ANZX
//								"wb"	...	oCiǂݏANZX
//								"ab"	...	oCiǉ݃ANZX
//							̏ԁE͖֌WB
//							ɂ̕LB
//							ftHg "rt"
//	3.	Ԓl
//		NULL	...	s
//		̑	...	it@C\̃AhXj
//	4.	l
//		s_option  NULL w肷 "rb" w肵ƂɂȂ
// -------------------------------------------------------------
FU_FILE* fu_open( const char* s_filename, const char* s_option )
{
	const char*	p_option;
	FU_FILE*	p_file = NULL;
	dword		n_option;
	bool		b_append;
	dword		n_access;

	//	nh擾
	p_file = ( FU_FILE* ) LocalAlloc( LPTR, sizeof( FU_FILE ) );
	if( p_file == NULL ) goto file_exit;

	p_file->n_mode = FU_MODE_FILE;

	//	IvV߂
	if( s_option == NULL ) {
		p_option = "rb";
	} else {
		p_option = s_option;
	}

	p_file->b_binary	= false;								//	ftHg̓eLXg
	n_option			= GENERIC_READ;							//	ftHg̓[h
	b_append			= false;								//	ftHg͐擪ANZX
	n_access			= OPEN_EXISTING;						//	ftHg݂͑t@CɃANZX

	while( *p_option != '\0' ) {
		switch( tu_to_upper( *p_option ) ) {
		case 'R':
			n_option = GENERIC_READ;
			n_access = OPEN_EXISTING;
			break;
		case 'W':
			n_option = GENERIC_WRITE;
			n_access = CREATE_ALWAYS;
			break;
		case 'T':
			p_file->b_binary = false;
			break;
		case 'B':
			p_file->b_binary = true;
			break;
		case 'A':
			b_append = true;
		}
		++p_option;
	}

	//	t@CJ
	p_file->h_file = CreateFile( s_filename, n_option, FILE_SHARE_READ, NULL, n_access,
						FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, NULL );
	if( p_file->h_file == INVALID_HANDLE_VALUE ) goto file_exit;

	//	ȏꍇ
	return p_file;

	//	G[̏ꍇ
file_exit:
	if( p_file != NULL ) LocalFree( p_file );
	return NULL;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		AJ
//	2.	
//		p_memory	...	(I)	N惁
//		n_size		...	(I)	TCYioCgj
//	3.	Ԓl
//		NULL	...	s
//		̑	...	it@C\̃AhXj
//	4.	l
//		p_memory Ŏ郁ɃANZX\ȃt@C\
//		ԂBfu_close Ă p_memory ͉ȂB
//		ꍇ̓AvIO fu_close Ă΂˂΂ȂȂB
//		ANZX[h́AɃoCiA[hCgB
//		p_memory ̕s̓`FbNȂB
// -------------------------------------------------------------
FU_FILE* fu_open_linkmemory( void* p_memory, dword n_size )
{
	FU_FILE*	p_file = NULL;

	//	nh擾
	p_file = ( FU_FILE* ) LocalAlloc( LPTR, sizeof( FU_FILE ) );
	if( p_file == NULL ) goto file_exit;

	p_file->n_mode = FU_MODE_LINKMEMORY;

	//	IvV߂
	p_file->b_binary	= true;									//	oCi

	//	A
	p_file->n_size		= n_size;
	p_file->p_memory	= ( byte* ) p_memory;
	p_file->n_pointer	= 0;

	//	ȏꍇ
	return p_file;

	//	G[̏ꍇ
file_exit:
	if( p_file != NULL ) LocalFree( p_file );
	return NULL;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		mۃJ
//	2.	
//		n_size		...	(I)	TCYioCgj
//	3.	Ԓl
//		NULL	...	s
//		̑	...	it@C\̃AhXj
//	4.	l
//		fu_close ƊmۂB
//		ꍇ̓AvIO fu_close Ă΂˂΂ȂȂB
//		ANZX[h́AɃoCiA[hCgB
// -------------------------------------------------------------
FU_FILE* fu_open_allocmemory( dword n_size )
{
	FU_FILE*	p_file = NULL;

	//	nh擾
	p_file = ( FU_FILE* ) LocalAlloc( LPTR, sizeof( FU_FILE ) );
	if( p_file == NULL ) goto file_exit;

	p_file->n_mode = FU_MODE_ALLOCMEMORY;

	//	IvV߂
	p_file->b_binary	= true;									//	oCi

	//	A
	p_file->n_size		= n_size;
	p_file->p_memory	= ( byte* ) LocalAlloc( LPTR, n_size );
	p_file->n_pointer	= 0;
	if( p_file->p_memory == NULL ) goto file_exit;

	//	ȏꍇ
	return p_file;

	//	G[̏ꍇ
file_exit:
	if( p_file != NULL ) LocalFree( p_file );
	return NULL;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		 p_file w肵Ă͂ȂȂ
// -------------------------------------------------------------
void fu_close( FU_FILE* p_file )
{
	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) return;

	switch( p_file->n_mode ) {
	case FU_MODE_FILE:
		//	t@C
		CloseHandle( p_file->h_file );
		break;
	case FU_MODE_LINKMEMORY:
		//	ȂɂȂ
		break;
	case FU_MODE_ALLOCMEMORY:
		//	
		LocalFree( p_file->p_memory );
		break;
	}

	//	t@C\̂
	LocalFree( p_file );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@Cɕo͂
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_format	...	(I)	o͂鏑
//		...			...	(I)	Q
//	3.	Ԓl
//		Ȃ
//	4.	l
//		eLXg[h̏ꍇA\n  \r\n ɕϊďo͂
// -------------------------------------------------------------
void fu_printf( FU_FILE* p_file, const char* s_format, ... )
{
	va_list	mark;
	char	s_buffer[ FU_BUFFER_LENGTH ];

	//	Xg̎擾
	va_start( mark, s_format );

	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) goto printf_exit;

	//	ɍ\
	vsprintf( s_buffer, s_format, mark );

	//	o
	fu_write( p_file, s_buffer, lstrlen( s_buffer ) );

printf_exit:
	va_end( mark );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C̏I[ɒBǂׂ
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//	3.	Ԓl
//		true	...	I[ɒBĂ
//		false	...	I[ɒBĂȂ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool fu_eof( FU_FILE* p_file )
{
	byte	s_buffer;

	//	PoCgǂł݂
	if( fu_read( p_file, &s_buffer, 1 ) == 0 ) return true;

	//	t@C|C^PoCg߂
	fu_seek( p_file, -1, FILE_CURRENT );

	return false;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		Ps͂
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_buffer	...	(O)	̓f[^̊i[AhX
//		n_size		...	(I)	s_buffer ̃TCY
//	3.	Ԓl
//		s_buffer
//	4.	l
//		Ȃ莸sꍇ́As_buffer  "" i[
//		r܂œǂݍ񂾏ꍇ́Aǂݍ񂾂Ƃ܂ł s_buffer
//		Ɋi[
//		eLXg[h̏ꍇ́A\r\n  \n ɕϊ
// -------------------------------------------------------------
char* fu_gets( FU_FILE* p_file, char* s_buffer, int n_size )
{
	char	s_template[ FU_BUFFER_LENGTH ];
	char*	p_template;
	int		i;

	//	NA
	memset( s_template, 0, sizeof( s_template ) );

	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) goto gets_exit;

	//	Ps͂
	p_template = s_template;
	for( i = 0; i < FU_BUFFER_LENGTH-1; ++i ) {
		//	PoCg
		if( !fu_read( p_file, p_template, 1 ) ) break;
		//	sȂ甲
		if( *p_template == '\n' ) break;
		//	
		++p_template;
	}

gets_exit:
	//	Rs[
	lstrcpy( s_buffer, s_template );

	//	eLXg[hȂR[hϊ
	if( !p_file->b_binary ) _fu_change_crlf( s_buffer );

	return s_buffer;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		w̃oCgo
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_buffer	...	(I)	of[^̃AhX
//		n_size		...	(I)	of[^̃TCY byte
//	3.	Ԓl
//		ooCg
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int fu_write( FU_FILE* p_file, const void* s_buffer, int n_size )
{
	dword	n_template	= 0;
	byte*	p_buffer	= (byte*) s_buffer;

	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) goto write_exit;

	switch( p_file->n_mode ) {
	case FU_MODE_FILE:
		//	t@C̏o
		if( !WriteFile( p_file->h_file, s_buffer, n_size, &n_template, NULL ) ) goto write_exit;
		break;
	case FU_MODE_LINKMEMORY:
	case FU_MODE_ALLOCMEMORY:
		//	̏o
		n_template = n_size;
		for( ; p_file->n_pointer < p_file->n_size && n_size; --p_file->n_pointer, --n_size ) {
			p_file->p_memory[ p_file->n_pointer ] = *p_buffer;
			++p_buffer;
		}
		n_template -= n_size;
		break;
	}

write_exit:
	return n_template;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		w̃oCgǂݍ
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_buffer	...	(O)	ǂݍݐAhX
//		n_size		...	(I)	ǂݍރf[^̃TCY byte
//	3.	Ԓl
//		ǂݏooCg
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int fu_read( FU_FILE* p_file, void* s_buffer, int n_size )
{
	dword	n_template	= 0;
	byte*	p_buffer	= (byte*) s_buffer;

	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) goto read_exit;

	switch( p_file->n_mode ) {
	case FU_MODE_FILE:
		//	t@C̓ǂݏo
		if( !ReadFile( p_file->h_file, s_buffer, n_size, &n_template, NULL ) ) goto read_exit;
		break;
	case FU_MODE_LINKMEMORY:
	case FU_MODE_ALLOCMEMORY:
		//	̓ǂݏo
		n_template = n_size;
		for( ; p_file->n_pointer < p_file->n_size && n_size; --p_file->n_pointer, --n_size ) {
			*p_buffer = p_file->p_memory[ p_file->n_pointer ];
			++p_buffer;
		}
		n_template -= n_size;
		break;
	}

read_exit:
	return n_template;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CV[N
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		n_offset	...	(I)	t@Cʒu
//		n_origin	...	(I)	V[Nʒu
//							FU_SEEK_TOP		...	t@C擪
//							FU_SEEK_CURRENT	...	݈ʒu
//							FU_SEEK_BOTTOM	...	t@CI[
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool fu_seek( FU_FILE* p_file, sint32 n_offset, int n_origin )
{
	dword	n_template;

	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) return false;

	switch( p_file->n_mode ) {
	case FU_MODE_FILE:
		if( SetFilePointer( p_file->h_file, n_offset, NULL, n_origin ) == 0xFFFFFFFF ) return false;
		break;
	case FU_MODE_LINKMEMORY:
	case FU_MODE_ALLOCMEMORY:
		//	ʒu
		switch( n_origin ) {
		case FU_SEEK_TOP:		n_template = 0;						break;
		case FU_SEEK_CURRENT:	n_template = p_file->n_pointer;		break;
		case FU_SEEK_BOTTOM:	n_template = p_file->n_size - 1;	break;
		default:				n_template = p_file->n_pointer;
		}
		//	͂ݏoȂ
		n_template += n_offset;
		if( n_template < 0 || n_template >= p_file->n_size ) return false;
		p_file->n_pointer = n_template;
		break;
	}

	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C̒߂
//	2.	
//		p_file	...	(I)	t@Cnh
//	3.	Ԓl
//		t@C̒
//	4.	l
//		Sfaȓ̃t@Ĉ
// -------------------------------------------------------------
unsigned long fu_length( FU_FILE* p_file ) {
	unsigned long	size;

	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( !_fu_check_enable( p_file ) ) return false;

	switch( p_file->n_mode ) {
	case FU_MODE_FILE:
		size = GetFileSize( p_file->h_file, NULL );
		if( size == 0xFFFFFFFF ) size = 0;
		break;
	case FU_MODE_LINKMEMORY:
	case FU_MODE_ALLOCMEMORY:
		size = p_file->n_size;
		break;
	}

	return size;
}

// =============================================================
//	⏕֐

// -------------------------------------------------------------
//	1.	{ꖼ
//		nh炩Ɉُ킩ׂ
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//	3.	Ԓl
//		true	...	̉\
//		false	...	ُ
//	4.	l
//		̍\̂w肵ꍇ́Atrue Ԃꍇ
// -------------------------------------------------------------
inline bool _fu_check_enable( FU_FILE* p_file )
{
	//	炩Ɉُȏꍇ͂ȂɂȂ
	if( p_file == NULL ) return false;
	if( p_file->h_file == NULL ) return false;

	return true;
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		\n  \r\n ɕϊ
//	2.	
//		s_buffer	...	(O)	ϊ̃f[^i[AhX
//							ϊʂɊi[
//	3.	Ԓl
//		Ȃ
//	4.	l
//		s_buffer  '\0' I[ƂĊ܂܂˂΂ȂȂ
//		ϊオ FU_BUFFER_LENGTH Ɏ܂Ȃ΂ȂȂ
// -------------------------------------------------------------
void _fu_change_cr( char* s_buffer )
{
	char	s_template[ FU_BUFFER_LENGTH ];
	char	*p_buffer, *p_template;

	//	ϊȂ s_template Ɋi[
	p_buffer	= s_buffer;
	p_template	= s_template;
	while( *p_buffer != '\0' ) {
		if( *p_buffer == '\n' ) {
			*p_template = '\r';
		}
		*p_template = *p_buffer;
		//	̕
		++p_template;
		++p_buffer;
	}
	*p_template = *p_buffer;
	lstrcpy( s_buffer, s_template );
}

// -------------------------------------------------------------
//	1.	{ꖼ
//		\r\n  \n ɕϊ
//	2.	
//		s_buffer	...	(O)	ϊ̃f[^i[AhX
//							ϊʂɊi[
//	3.	Ԓl
//		Ȃ
//	4.	l
//		s_buffer  '\0' I[ƂĊ܂܂˂΂ȂȂ
//		ϊオ FU_BUFFER_LENGTH Ɏ܂Ȃ΂ȂȂ
// -------------------------------------------------------------
void _fu_change_crlf( char* s_buffer )
{
	char	s_template[ FU_BUFFER_LENGTH ];
	char	*p_buffer, *p_template;

	//	ϊȂ s_template Ɋi[
	p_buffer	= s_buffer;
	p_template	= s_template;
	while( *p_buffer != '\0' ) {
		if( *p_buffer == '\r' ) {
			++p_template;
		}
		*p_template = *p_buffer;
		//	̕
		++p_template;
		++p_buffer;
	}
	*p_template = *p_buffer;
	lstrcpy( s_buffer, s_template );
}
