// -------------------------------------------------------------
//	TITLE		:	File Access Utility
//	FILE		:	fileuty.cpp
//	COPYRIGHT	:	(C)2001 t.hara
//	COMENT		:	t@CANZX֐Q
//					bW̃t@CANZX֐ƎC^[tF[X
//					̗p WindowsAPI x[X̊֐Q
//					bW̃t@CANZXɂssA
//					Windows ȊOւ̈ڐAێړI
//	HISTORY		:	2001/02/07	v0.00	Jn
//					2001/02/11	v1.00	{@\̎
//					2001/02/14	v1.01	ANZX@\ǉ
// -------------------------------------------------------------

#ifndef	_fileuty_h_
#define	_fileuty_h_

// =============================================================
//	CN[h

#include	"typeuty.h"											//	{^`

// =============================================================
//	ݒ

#ifdef	_WIN32
//	for Win32

#include <windows.h>

#define	FU_MAX_PATH_LENGTH	MAX_PATH							//	őpX
#define	FU_FILE_HANDLE		HANDLE								//	t@Cnh
#define	FU_BUFFER_LENGTH	10000								//	printf obt@TCY

#define	FU_SEEK_TOP			FILE_BEGIN							//	t@C̐擪V[N
#define	FU_SEEK_CURRENT		FILE_CURRENT						//	݈ʒuV[N
#define	FU_SEEK_BOTTOM		FILE_END							//	t@C̏IV[N

#define	FU_INVALID_HANDLE	NULL								//	sȃt@Cnh

#else
//	for Others	( Kvȕ́Afileuty.cpp ̕ɉč쐬Ă )

#include <stdio.h>

#define	FU_MAX_PATH_LENGTH	32768								//	őpX
#define	FU_FILE_HANDLE		FILE*								//	t@Cʎq
#define	FU_BUFFER_LENGTH	10000								//	printf obt@TCY

#define	FU_SEEK_TOP			SEEK_SET							//	t@C̐擪V[N
#define	FU_SEEK_CURRENT		SEEK_CUR							//	݈ʒuV[N
#define	FU_SEEK_BOTTOM		SEEK_END							//	t@C̏IV[N

#define	FU_INVALID_HANDLE	NULL								//	sȃt@Cnh

#endif

//	

typedef enum {
	FU_MODE_FILE,											//	t@C
	FU_MODE_LINKMEMORY,										//	AiȂj
	FU_MODE_ALLOCMEMORY,									//	mۃij
} FU_MODE;

// =============================================================
//	\

// -------------------------------------------------------------
//	t@C\
//	eFŗL̃t@C\

typedef struct fu_file_tag {
	FU_FILE_HANDLE	h_file;										//	t@Cnh
	bool			b_binary;									//	oCiȂ true , eLXgȂ false
	FU_MODE			n_mode;										//	Ώۃ[h
	dword			n_size;										//	TCY
	byte*			p_memory;									//	AhX
	dword			n_pointer;									//	|C^
} FU_FILE;

// =============================================================
//	֐vg^Cv

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CJ
//	2.	
//		s_filename	...	(I)	t@C
//		s_option	...	(I)	ANZXw
//								"rt"	...	eLXgǂݍ݃ANZX
//								"wt"	...	eLXgǂݏANZX
//								"at"	...	eLXgǉ݃ANZX
//								"rb"	...	oCiǂݍ݃ANZX
//								"wb"	...	oCiǂݏANZX
//								"ab"	...	oCiǉ݃ANZX
//							̏ԁE͖֌WB
//							ɂ̕LB
//							ftHg "rt"
//	3.	Ԓl
//		FU_INVALID_HANDLE	...	s
//		̑				...	it@C\̃AhXj
//	4.	l
//		s_option  NULL w肷 "rb" w肵ƂɂȂ
// -------------------------------------------------------------
FU_FILE* fu_open( const char* s_filename, const char* s_option );

// -------------------------------------------------------------
//	1.	{ꖼ
//		AJ
//	2.	
//		p_memory	...	(I)	N惁
//		n_size		...	(I)	TCYioCgj
//	3.	Ԓl
//		NULL	...	s
//		̑	...	it@C\̃AhXj
//	4.	l
//		p_memory Ŏ郁ɃANZX\ȃt@C\
//		ԂBfu_close Ă p_memory ͉ȂB
//		ꍇ̓AvIO fu_close Ă΂˂΂ȂȂB
//		ANZX[h́AɃoCiA[hCgB
//		p_memory ̕s̓`FbNȂB
// -------------------------------------------------------------
FU_FILE* fu_open_linkmemory( void* p_memory, dword n_size );

// -------------------------------------------------------------
//	1.	{ꖼ
//		mۃJ
//	2.	
//		n_size		...	(I)	TCYioCgj
//	3.	Ԓl
//		NULL	...	s
//		̑	...	it@C\̃AhXj
//	4.	l
//		fu_close ƊmۂB
//		ꍇ̓AvIO fu_close Ă΂˂΂ȂȂB
//		ANZX[h́AɃoCiA[hCgB
// -------------------------------------------------------------
FU_FILE* fu_open_allocmemory( dword n_size );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		 p_file w肵Ă͂ȂȂ
// -------------------------------------------------------------
void fu_close( FU_FILE* p_file );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@Cɕo͂
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_format	...	(I)	o͂鏑
//		...			...	(I)	Q
//	3.	Ԓl
//		Ȃ
//	4.	l
//		eLXg[h̏ꍇA\n  \r\n ɕϊďo͂
// -------------------------------------------------------------
void fu_printf( FU_FILE* p_file, const char* s_format, ... );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C̏I[ɒBǂׂ
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//	3.	Ԓl
//		true	...	I[ɒBĂ
//		false	...	I[ɒBĂȂ
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool fu_eof( FU_FILE* p_file );

// -------------------------------------------------------------
//	1.	{ꖼ
//		Ps͂
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_buffer	...	(O)	̓f[^̊i[AhX
//		n_size		...	(I)	s_buffer ̃TCY
//	3.	Ԓl
//		s_buffer
//	4.	l
//		Ȃ莸sꍇ́As_buffer  "" i[
//		r܂œǂݍ񂾏ꍇ́Aǂݍ񂾂Ƃ܂ł s_buffer
//		Ɋi[
//		eLXg[h̏ꍇ́A\r\n  \n ɕϊ
// -------------------------------------------------------------
char* fu_gets( FU_FILE* p_file, char* s_buffer, int n_size );

// -------------------------------------------------------------
//	1.	{ꖼ
//		w̃oCgo
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_buffer	...	(I)	of[^̃AhX
//		n_size		...	(I)	of[^̃TCY byte
//	3.	Ԓl
//		ooCg
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int fu_write( FU_FILE* p_file, const void* s_buffer, int n_size );

// -------------------------------------------------------------
//	1.	{ꖼ
//		w̃oCgǂݍ
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		s_buffer	...	(O)	ǂݍݐAhX
//		n_size		...	(I)	ǂݍރf[^̃TCY byte
//	3.	Ԓl
//		ǂݏooCg
//	4.	l
//		Ȃ
// -------------------------------------------------------------
int fu_read( FU_FILE* p_file, void* s_buffer, int n_size );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@CV[N
//	2.	
//		p_file		...	(I)	t@C\̃AhX
//		n_offset	...	(I)	t@Cʒu
//		n_origin	...	(I)	V[Nʒu
//							FU_SEEK_TOP		...	t@C擪
//							FU_SEEK_CURRENT	...	݈ʒu
//							FU_SEEK_BOTTOM	...	t@CI[
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		Ȃ
// -------------------------------------------------------------
bool fu_seek( FU_FILE* p_file, sint32 n_offset, int n_origin );

// -------------------------------------------------------------
//	1.	{ꖼ
//		t@C̒߂
//	2.	
//		p_file	...	(I)	t@Cnh
//	3.	Ԓl
//		t@C̒
//	4.	l
//		Sfaȓ̃t@Ĉ
// -------------------------------------------------------------
unsigned long fu_length( FU_FILE* p_file );

#endif	//	_fileuty_h_
