// -----------------------------------------------------
//	TITLE		:	Windows Utility
//	FILE		:	winuty.cpp
//	COPYRIGHT	:	(C)2001 t.hara
//	COMENT		:	Windows ⏕֐Q
//	HISTORY		:	2001/02/11	v0.00	Jn
// -----------------------------------------------------

// =====================================================
//	CN[h

#include "winuty.h"
#include <windowsx.h>

// =====================================================
//	ݒ

#define	WU_DEF_FILTER	"All files(*.*)\0*.*\0"

// =====================================================
//	ϐ

static HINSTANCE	h_ins = NULL;								//	AvP[VCX^Xnh

// =====================================================
//	֐`

// =====================================================
//	AvP[VW

// -----------------------------------------------------
//	1.	{ꖼ
//		CX^Xnho^
//	2.	
//		h_ins	...	(I)	CX^Xnh
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_set_instance( HINSTANCE h_ins )
{
	::h_ins = h_ins;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		CX^Xnh擾
//	2.	
//		Ȃ
//	3.	Ԓl
//		o^CX^Xnh
//	4.	l
//		Ȃ
// -----------------------------------------------------
HINSTANCE wu_get_instance( void )
{
	return ::h_ins;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		bZ[W
//	2.	
//		Ȃ
//	3.	Ԓl
//		true	...	
//		false	...	AvP[VIv
//	4.	l
//		Ȃ
// -----------------------------------------------------
bool wu_do_events( HWND h_wnd, HACCEL h_accel )
{
	MSG	msg;

	//	bZ[W CPU đҋ@
	if( !PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ){
		WaitMessage();
		return true;
	}

	//	bZ[W WM_QUIT ȂIvԂ
	if( !GetMessage( &msg, NULL, 0, 0 ) ) return false;

	//	ANZ[^w肳ĂΏ
	if( h_wnd != NULL && h_accel != NULL ) {
		if( TranslateAccelerator( h_wnd, h_accel, &msg ) ) return true;
	}

	//	gX[gƃfBXpb`
	TranslateMessage( &msg );
	DispatchMessage( &msg );

	return true;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ʓIȃEBhENX̐ݒ
//	2.	
//		p_wndclass	...	(O)	EBhENX\
//		p_class		...	(I)	EBhENX
//		n_icon		...	(I)	ACRhc
//		p_wndclass	...	(I)	EBhE֐
//	3.	Ԓl
//		Ȃ
//	4.	l
//		̊֐gO wu_set_instance ŃCX^Xnh
//		w肵Ă˂΂ȂȂ
// -----------------------------------------------------
void wu_get_wndclassex( WNDCLASSEX* p_wndclass, const char* p_class, int n_icon, WNDPROC p_wndproc )
{
	WNDCLASSEX*	&wc = p_wndclass;

	memset( wc, 0, sizeof( WNDCLASSEX ) );
	wc->cbSize			= sizeof( WNDCLASSEX );
	wc->hbrBackground	= ( HBRUSH ) GetStockObject( WHITE_BRUSH );
	wc->hCursor			= LoadCursor( NULL, IDC_ARROW );
	if( n_icon != NULL ) {
		wc->hIcon		= LoadIcon( h_ins, MAKEINTRESOURCE( n_icon ) );
		wc->hIconSm		= ( HICON ) LoadImage( h_ins, MAKEINTRESOURCE( n_icon ), 
							IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR );
	} else {
		wc->hIcon		= LoadIcon( NULL, IDI_APPLICATION );
		wc->hIconSm		= LoadIcon( NULL, IDI_APPLICATION );
	}
	wc->hInstance		= h_ins;
	wc->lpfnWndProc		= p_wndproc;
	wc->lpszClassName	= p_class;
	wc->lpszMenuName	= NULL;
	wc->style			= 0;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		EBhEݒ
//	2.	
//		*p_create		...	(O)	EBhE\
//		*p_class		...	(I)	EBhENX
//		*p_caption		...	(I)	EBhE^Cg
//		n_width			...	(I)	EBhE
//									0 ... ȗƌȂftHglݒ肷
//		n_height		...	(I)	EBhE
//									0 ... ȗƌȂftHglݒ肷
//	3.	Ԓl
//		Ȃ
//	4.	l
//		EBhEʒu͉ʂ̒t߂ɐݒ肳
// -----------------------------------------------------
void wu_get_createstruct( CREATESTRUCT* p_create,const char* p_class, const char* p_caption, int n_width, int n_height )
{
	RECT			r_size;
	CREATESTRUCT*	&c	= p_create;

	memset( p_create, 0, sizeof( CREATESTRUCT ) );

	c->lpszClass		= p_class;
	c->lpszName			= p_caption;

	GetClientRect( GetDesktopWindow(), &r_size );

	if( n_width ){
		c->cx			= n_width;
	}else{
		c->cx			= 100;
	}

	if( n_height ){
		c->cy			= n_height;
	}else{
		c->cy			= 100;
	}

	c->x				= ( r_size.right  - c->cx ) / 2;
	c->y				= ( r_size.bottom - c->cy ) / 2;
	c->hMenu			= NULL;
	c->hwndParent		= NULL;
	c->dwExStyle		= 0;
	c->style			= WS_CAPTION | WS_POPUPWINDOW | WS_MINIMIZEBOX;
	c->hInstance		= h_ins;
	c->lpCreateParams	= NULL;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		EBhE̍쐬
//	2.	
//		p_create	...	(I)	EBhEp[^
//	3.	Ԓl
//		NULL		...	EBhEs
//					...	EBhẼEBhEnh
//	4.	l
//		EBhEsv͎̂Q
//			(1)	EBhEp[^ɕsꍇ
//			(2)	WM_CREATE Cxg -1 Ԃꂽꍇ
//		̊֐̌Ăяô݂ł͂ʂłȂB֐Ă
//		oOɃO[oϐɋKli[AWM_CREATE ̏
//		擪ɂĕʂ̋Kli[B̃O[oϐQƂ
//		邱Ƃŋʂ邱ƂłB
// -----------------------------------------------------
HWND wu_create_window( CREATESTRUCT* p_create )
{
	return( CreateWindowEx( p_create->dwExStyle, p_create->lpszClass, p_create->lpszName,
				p_create->style, p_create->x, p_create->y, p_create->cx, p_create->cy,
				p_create->hwndParent, p_create->hMenu, p_create->hInstance, p_create->lpCreateParams ) );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		st@C݂̑fBNg擾
//	2.	
//		p_buffer	...	(O)	pXo͂obt@̃AhX
//	3.	Ԓl
//		Ȃ
//	4.	l
//		obt@ MAX_PATH ̃TCYmۂĂΏ\
// -----------------------------------------------------
void wu_get_exe_path( char* p_buffer )
{
	char		*p_path;

	p_path	= GetCommandLine();
	lstrcpy( p_buffer, p_path );
	p_path	= strrchr( p_buffer, '\\' );
	*p_path	= '\0';
}

// -----------------------------------------------------
//	1.	{ꖼ
//		t@CJ_CAO\iPƃt@Cj
//	2.	
//		h_wnd		...	(I)		eEBhEnh
//		p_name		...	(I/O)	ftHgt@C
//								Iꂽt@Ci[B
//		p_filter	...	(I/O)	gq
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		p_name  MAX_PATH ̃TCYKv
// -----------------------------------------------------
bool wu_dialog_select_open_file( HWND h_wnd, char* p_name, const char* p_filter )
{
	OPENFILENAME	ofn;

	memset( &ofn, 0, sizeof( ofn ) );
	ofn.hInstance	= h_ins;
	ofn.hwndOwner	= h_wnd;
	ofn.lStructSize	= sizeof( ofn );
	if( p_filter != NULL ) {
		ofn.lpstrFilter	= p_filter;
	} else {
		ofn.lpstrFilter	= WU_DEF_FILTER;
	}
	ofn.Flags		= OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_EXPLORER
					| OFN_ENABLESIZING;
	ofn.lpstrFile	= p_name;
	ofn.nMaxFile	= MAX_PATH;
	ofn.nFilterIndex= 1;
	return( GetOpenFileName( &ofn ) != FALSE );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		t@CJ_CAO\it@Cj
//	2.	
//		h_wnd		...	(I)		eEBhEnh
//		p_name		...	(I/O)	ftHgt@C
//								Iꂽt@Ci[B
//		p_filter	...	(I/O)	gq
//	3.	Ԓl
//		true	...	
//		false	...	s
//	4.	l
//		p_name  MAX_PATH ̃TCYKv
// -----------------------------------------------------
bool wu_dialog_multi_select_open_file( HWND h_wnd, char* p_name, const char* p_filter )
{
	OPENFILENAME	ofn;

	memset( &ofn, 0, sizeof( ofn ) );
	ofn.hInstance	= h_ins;
	ofn.hwndOwner	= h_wnd;
	ofn.lStructSize	= sizeof( ofn );
	if( p_filter != NULL ) {
		ofn.lpstrFilter	= p_filter;
	} else {
		ofn.lpstrFilter	= WU_DEF_FILTER;
	}
	ofn.Flags		= OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_EXPLORER
					| OFN_ENABLESIZING | OFN_ALLOWMULTISELECT;
	ofn.lpstrFile	= p_name;
	ofn.nMaxFile	= MAX_PATH;
	ofn.nFilterIndex= 1;
	return( GetOpenFileName( &ofn ) != FALSE );
}

// =====================================================
//	EBhEėp֐

// -----------------------------------------------------
//	1.	{ꖼ
//		NCAg̈̃TCYw
//	2.	
//		h_wnd		...	(I)	EBhEnh
//		n_width		...	(I)	
//		n_height	...	(I)	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		̎sAݒs\Ȃ炠߂
// -----------------------------------------------------
void wu_set_client_rect( HWND h_wnd, int n_width, int n_height )
{
	RECT	r_size, r_winsize;
	int		i;

	for( i = 0; i < 3; ++i ) {
		//	TCY擾
		GetClientRect( h_wnd, &r_size );
		GetWindowRect( h_wnd, &r_winsize );

		//	TCY̔r
		if( r_size.right == n_width && r_size.bottom == n_height ) break;

		//	TCY̒
		r_size.right	= r_winsize.right  + ( n_width  - r_size.right  ) - r_winsize.left;
		r_size.bottom	= r_winsize.bottom + ( n_height - r_size.bottom ) - r_winsize.top;

		//	EBhETCY̕ύX
		SetWindowPos( h_wnd, 0, 0, 0, r_size.right, r_size.bottom,
			SWP_NOOWNERZORDER | SWP_NOMOVE | SWP_NOZORDER );
	}
}

// -----------------------------------------------------
//	1. ֐
//		EBhE  w̃EBhE ̒ֈړ
//	2. 
//		h_wnd		...	(I)	Ώۂ̃EBhEnh
//		h_basewnd	...	(I)	̃EBhEnh
//	3. Ԓl
//		Ȃ
//	4. l
//		ƑΏۂ̃EBhE̐eq֌WȂǂ͖Ȃ
//		 NULL ɂƃfXNgbvɂ
// -----------------------------------------------------
void wu_move_center( HWND h_wnd, HWND h_basewnd )
{
	RECT	r_wsize, r_bsize;
	HWND	h_pwnd;
	POINT	p;

	// EBhEw̏ꍇ̓fXNgbvɂ
	if( h_basewnd == NULL ) h_basewnd = GetDesktopWindow();

	// EBhËʒuƃTCY߂
	memset( &r_wsize, 0, sizeof( RECT ) );
	memset( &r_bsize, 0, sizeof( RECT ) );
	GetWindowRect( h_wnd,		&r_wsize );
	GetWindowRect( h_basewnd,	&r_bsize );

	// ʒuZo(XN[W)
	p.x = ( ( r_bsize.left + r_bsize.right  ) - ( r_wsize.right  - r_wsize.left ) ) / 2;	
	p.y = ( ( r_bsize.top  + r_bsize.bottom ) - ( r_wsize.bottom - r_wsize.top  ) ) / 2;
	
	// EBhEړ
	h_pwnd = GetParent( h_wnd );
	
	if( h_pwnd != NULL && (GetWindowLong( h_wnd, GWL_STYLE ) & WS_CHILD) ){

		// eĂꍇ͐eEBhEWnɕϊ
		ScreenToClient( h_pwnd, &p );
	}

	SetWindowPos( h_wnd, 0, p.x, p.y, 0, 0, SWP_NOZORDER | SWP_NOOWNERZORDER | SWP_NOSIZE );
}

// =====================================================
//	Xgr[֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		̐擾
//	2.	
//		h_wnd		...	(I)	eEBhEnh
//		n_id		...	(I)	Xgr[̂hc
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
int wu_listview_get_column_count( HWND h_wnd, int n_id )
{
	HWND		h_list;
	LVCOLUMN	lvcolumn;
	int			n_cnt;

	h_list			= GetDlgItem( h_wnd, n_id );
	n_cnt			= 0;
	memset( &lvcolumn, 0, sizeof( lvcolumn ) );
	lvcolumn.mask	= LVCF_WIDTH;
	while( ListView_GetColumn( h_list, n_cnt, &lvcolumn ) ) ++n_cnt;
	return n_cnt;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ǉ
//	2.	
//		h_wnd		...	(I)	eEBhEnh
//		n_id		...	(I)	Xgr[̂hc
//		s_name		...	(I)	
//		n_width		...	(I)	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_listview_add_column( HWND h_wnd, int n_id, const char* s_name, int n_width )
{
	HWND		h_list;
	LVCOLUMN	lvcolumn;
	int			n_cnt;

	h_list = GetDlgItem( h_wnd, n_id );

	//	񐔂擾i擪ۂ肷邽߁j
	n_cnt = wu_listview_get_column_count( h_wnd, n_id );

	//	ǉ
	memset( &lvcolumn, 0, sizeof( lvcolumn ) );
	lvcolumn.mask		= LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	if( n_cnt ) lvcolumn.mask |= LVCF_SUBITEM;
	lvcolumn.fmt		= LVCFMT_LEFT;
	lvcolumn.pszText	= (char*)s_name;
	lvcolumn.cx			= n_width;
	lvcolumn.iSubItem	= n_cnt;
	ListView_InsertColumn( h_list, n_cnt, &lvcolumn );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ڐ擾
//	2.	
//		h_wnd	...	(I)	eEBhE
//		n_id	...	(I)	Xgr[̂hc
//	3.	Ԓl
//		ڐ
//	4.	l
//		Ȃ
// -----------------------------------------------------
int wu_listview_get_count( HWND h_wnd, int n_id )
{
	HWND		h_list;

	h_list = GetDlgItem( h_wnd, n_id );

	return ListView_GetItemCount( h_list );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Vڂ̒ǉ
//	2.	
//		h_wnd	...	(I)	eEBhE
//		n_id	...	(I)	Xgr[̂hc
//		s_name	...	(I)	ǉ鍀ږ
//	3.	Ԓl
//		}ڂ̃CfbNXisԍj
//	4.	l
//		Ȃ
// -----------------------------------------------------
int wu_listview_add_item( HWND h_wnd, int n_id, const char* s_name )
{
	LV_ITEM		lvitem;
	HWND		h_list;

	h_list = GetDlgItem( h_wnd, n_id );

	memset( &lvitem, 0, sizeof( lvitem ) );

	lvitem.mask		= LVIF_TEXT;
	lvitem.pszText	= (char*)s_name;
	lvitem.iItem	= wu_listview_get_count( h_wnd, n_id );
	lvitem.iSubItem	= 0;
	return ListView_InsertItem( h_list, &lvitem );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		ڂ̃TuACe̐ݒ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xgr[̂hc
//		n_row	...	(I)	TuACe̍sԍ
//		n_col	...	(I)	TuACe̗ԍ
//		s_name	...	(I)	TuACeɐݒ肷镶
//	3.	Ԓl
//		Ȃ
//	4.	l
//		n_col  0 ɂƍږύXł
//		n_row  -1 ɂƍŌ̍sΏۂƂ
// -----------------------------------------------------
void wu_listview_set_subitem( HWND h_wnd, int n_id, int n_row, int n_col,const char* s_name )
{
	LV_ITEM		lvitem;
	HWND		h_list;

	h_list = GetDlgItem( h_wnd, n_id );

	if( n_row == -1 ) n_row = wu_listview_get_count( h_wnd, n_id )-1;

	memset( &lvitem, 0, sizeof( lvitem ) );

	lvitem.mask		= LVIF_TEXT;
	lvitem.pszText	= (char*)s_name;
	lvitem.iItem	= n_row;
	lvitem.iSubItem	= n_col;
	ListView_SetItem( h_list, &lvitem );
}

// =====================================================
//	R{{bNX֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		R{{bNXɕ̕ǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	R{{bNXID
//		s_array	...	(I)	|C^̔zAhX
//		n_count	...	(I)	s_array ̗vf
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_combo_set_items( HWND h_wnd, int n_id, const char* s_array[], int n_count )
{
	int		i;
	HWND	h_combo;

	h_combo = GetDlgItem( h_wnd, n_id );

	for( i = 0; i < n_count; ++i ) {
		ComboBox_AddString( h_combo, s_array[ i ] );
	}
}

// -----------------------------------------------------
//	1.	{ꖼ
//		R{{bNX̑IJ[\ʒuw肷
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	R{{bNXID
//		n_index	...	(I)	Iʒu
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_combo_set_index( HWND h_wnd, int n_id, int n_index )
{
	HWND	h_combo;

	h_combo = GetDlgItem( h_wnd, n_id );
	
	ComboBox_SetCurSel( h_combo, n_index );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		R{{bNX̑IJ[\ʒu擾
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	R{{bNXID
//	3.	Ԓl
//		CfbNXl
//	4.	l
//		Ȃ
// -----------------------------------------------------
int wu_combo_get_index( HWND h_wnd, int n_id )
{
	HWND	h_combo;

	h_combo = GetDlgItem( h_wnd, n_id );
	
	return ComboBox_GetCurSel( h_combo );
}

// =====================================================
//	{^֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		{^ɃACRZbg
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	{^ID
//		hIcon	...	(I)	ZbgACR
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_button_set_icon( HWND h_wnd, int n_id, HICON hIcon )
{
	HWND	h_button;

	h_button = GetDlgItem( h_wnd, n_id );
	
	SendMessage( h_button, BM_SETIMAGE, IMAGE_ICON, (LPARAM) hIcon ); 
}

// -----------------------------------------------------
//	1.	{ꖼ
//		{^̃`FbNԂZbg
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	{^ID
//		b_check	...	(I)	`FbN
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_button_set_check( HWND h_wnd, int n_id, bool b_check )
{
	HWND	h_button;

	h_button = GetDlgItem( h_wnd, n_id );
	
	SendMessage( h_button, BM_SETCHECK, b_check ? BST_CHECKED : BST_UNCHECKED, 0 ); 
}

// -----------------------------------------------------
//	1.	{ꖼ
//		{^̃`FbNԂ擾
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	{^ID
//	3.	Ԓl
//		true	...	`FbNς
//		false	...	`FbNAOC
//	4.	l
//		Ȃ
// -----------------------------------------------------
bool wu_button_get_check( HWND h_wnd, int n_id )
{
	HWND	h_button;

	h_button = GetDlgItem( h_wnd, n_id );
	
	return( SendMessage( h_button, BM_GETCHECK, 0, 0 ) == BST_CHECKED ); 
}

// =====================================================
//	j[֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		j[̃`FbNԂw肷
//	2.	
//		h_wnd	...	(I)	j[EBhEnh
//		n_id	...	(I)	j[ACeID
//		b_check	...	(I)	`FbN
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_menu_set_check( HWND h_wnd, int n_id, BOOL b_check )
{
	HMENU	h_menu;

	//	j[̎擾
	h_menu = GetMenu( h_wnd );
	if( h_menu == NULL ) return;

	//	`FbNԂ̐ݒ
	MENUITEMINFO	mi;

	memset( &mi, 0, sizeof( mi ) );
	mi.cbSize	= sizeof( mi );
	GetMenuItemInfo( h_menu, n_id, FALSE, &mi );
	mi.fMask	= MIIM_STATE;
	if( b_check ) {
		mi.fState	= MFS_CHECKED;
	} else {
		mi.fState	= MFS_UNCHECKED;
	}
	SetMenuItemInfo( h_menu, n_id, FALSE, &mi );

	SetMenu( h_wnd, h_menu );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		j[̗Lݒ肷
//	2.	
//		h_wnd	...	(I)	j[EBhEnh
//		n_id	...	(I)	j[ACeID
//		b_enable	...	(I)	L
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_menu_enabled( HWND h_wnd, int n_id, BOOL b_enable )
{
	HMENU	h_menu;

	//	j[̎擾
	h_menu = GetMenu( h_wnd );
	if( h_menu == NULL ) return;

	//	`FbNԂ̐ݒ
	MENUITEMINFO	mi;

	memset( &mi, 0, sizeof( mi ) );
	mi.cbSize	= sizeof( mi );
	GetMenuItemInfo( h_menu, n_id, FALSE, &mi );
	mi.fMask	= MIIM_STATE;
	if( b_enable ) {
		mi.fState	= MFS_ENABLED;
	} else {
		mi.fState	= MFS_DISABLED | MFS_GRAYED;
	}
	SetMenuItemInfo( h_menu, n_id, FALSE, &mi );

	SetMenu( h_wnd, h_menu );
}

// =====================================================
//	Xg{bNX֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		Xg{bNXɕ̕ǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xg{bNXID
//		s_array	...	(I)	|C^̔zAhX
//		n_count	...	(I)	s_array ̗vf
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_list_set_items( HWND h_wnd, int n_id, const char* s_array[], int n_count )
{
	int		i;
	HWND	h_list;

	h_list = GetDlgItem( h_wnd, n_id );

	for( i = 0; i < n_count; ++i ) {
		ListBox_AddString( h_list, s_array[ i ] );
	}
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Xg{bNXɕǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xg{bNXID
//		s_name	...	(I)	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_list_add_item( HWND h_wnd, int n_id, const char* s_name )
{
	HWND	h_list;

	h_list = GetDlgItem( h_wnd, n_id );

	ListBox_AddString( h_list, s_name );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Xg{bNXɂ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xg{bNXID
//		s_name	...	(I)	
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_list_clear( HWND h_wnd, int n_id )
{
	HWND	h_list;

	h_list = GetDlgItem( h_wnd, n_id );

	ListBox_ResetContent( h_list );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Xg{bNX̑IJ[\ʒuw肷
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xg{bNXID
//		n_index	...	(I)	Iʒu
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_list_set_index( HWND h_wnd, int n_id, int n_index )
{
	HWND	h_list;

	h_list = GetDlgItem( h_wnd, n_id );
	
	ListBox_SetCurSel( h_list, n_index );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		Xg{bNX̑IJ[\ʒu擾
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	Xg{bNXID
//	3.	Ԓl
//		CfbNXl
//	4.	l
//		Ȃ
// -----------------------------------------------------
int wu_list_get_index( HWND h_wnd, int n_id )
{
	HWND	h_list;

	h_list = GetDlgItem( h_wnd, n_id );
	
	return ListBox_GetCurSel( h_list );
}

// =====================================================
//	^uRg[֘A

// -----------------------------------------------------
//	1.	{ꖼ
//		^uRg[̍ڐ擾
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	^uRg[ID
//	3.	Ԓl
//		ڐ
//	4.	l
//		s 0 Ԃ
// -----------------------------------------------------
int wu_tab_get_count( HWND h_wnd, int n_id )
{
	HWND	h_tab;

	h_tab = GetDlgItem( h_wnd, n_id );

	return TabCtrl_GetItemCount( h_tab );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		^uRg[ɍڂǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	^uRg[ID
//		s_name	...	(I)	ǉ^u
//	3.	Ԓl
//		-1	...	s
//			...	V^ũCfbNX
//	4.	l
//		o^ς݃^u̍Ōɒǉ
// -----------------------------------------------------
int wu_tab_add_item( HWND h_wnd, int n_id, const char* s_name )
{
	HWND	h_tab;
	int		n_index;
	TC_ITEM	tc;

	h_tab = GetDlgItem( h_wnd, n_id );
	memset( &tc, 0, sizeof( tc ) );
	tc.mask		= TCIF_TEXT;
	tc.pszText	= (LPSTR)s_name;
	n_index		= wu_tab_get_count( h_wnd, n_id );

	return TabCtrl_InsertItem( h_tab, n_index, &tc );
}

// -----------------------------------------------------
//	1.	{ꖼ
//		^uRg[ɕ̕ǉ
//	2.	
//		h_wnd	...	(I)	eEBhEnh
//		n_id	...	(I)	^uRg[ID
//		s_array	...	(I)	|C^̔zAhX
//		n_count	...	(I)	s_array ̗vf
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_tab_set_items( HWND h_wnd, int n_id, const char* s_array[], int n_count )
{
	int		i;

	for( i = 0; i < n_count; ++i ) {
		wu_tab_add_item( h_wnd, n_id, s_array[ i ] );
	}
}

// =====================================================
//	c[`bv

// -----------------------------------------------------
//	1.	{ꖼ
//		c[`bv쐬
//	2.	
//		hWnd	...	(I)	eEBhEnh
//	3.	Ԓl
//		!NULL	...	c[`bṽEBhEnh
//		NULL	...	s
//	4.	l
//		Ȃ
// -----------------------------------------------------
HWND wu_ttip_create( HWND hWnd )
{
    HWND	hToolTip;

	hToolTip = CreateWindowEx(
				0,						//	gX^C
				TOOLTIPS_CLASS,
				NULL,
				TTS_ALWAYSTIP,			//	X^C
				CW_USEDEFAULT,
				CW_USEDEFAULT,
				CW_USEDEFAULT,
				CW_USEDEFAULT,
				hWnd,					// e
				NULL,
				h_ins,
				NULL );

    SendMessage( hToolTip, TTM_ACTIVATE, (WPARAM)TRUE, 0);
	
	return hToolTip;
}

// -----------------------------------------------------
//	1.	{ꖼ
//		c[`bvɕ\Ώۂǉ
//	2.	
//		hTip	...	c[`bṽnh
//		nId		...	Rg[̂hc
//		s_tips	...	\镶
//	3.	Ԓl
//		Ȃ
//	4.	l
//		Ȃ
// -----------------------------------------------------
void wu_ttip_set_item( HWND hTip, int nId, char* s_tips )
{
    TOOLINFO	ti;
	RECT		rect;
	POINT		pt;
	HWND		hWnd = GetParent( hTip );

	GetWindowRect( GetDlgItem( hWnd, nId ), &rect );

	pt.x = rect.left;
	pt.y = rect.top;
	ScreenToClient( hWnd, &pt );
	ti.rect.left = pt.x;
	ti.rect.top  = pt.y;

	pt.x = rect.right;
	pt.y = rect.bottom;
	ScreenToClient( hWnd, &pt );
	ti.rect.right  = pt.x;
	ti.rect.bottom = pt.y;

	memset( &ti, 0, sizeof( ti ) );
	ti.cbSize	= sizeof( TOOLINFO );
    ti.hwnd		= hWnd;
    ti.hinst	= h_ins;
    ti.uFlags	= TTF_SUBCLASS | TTF_IDISHWND;
	ti.uId		= (WPARAM)GetDlgItem( hWnd, nId );
	ti.lpszText = (LPTSTR)s_tips;
	SendMessage( hTip, TTM_ADDTOOL, 0, (LPARAM)&ti );
}
